Name:		libssh2
Version:	1.9.0
Release:	6
Summary:	A library implementing the SSH2 protocol
License:	BSD
URL:		https://www.libssh2.org/
Source0:	https://libssh2.org/download/libssh2-%{version}.tar.gz

Patch0:      	0001-libssh2-CVE-2019-17498.patch
Patch1:      	0001-libssh2-misc.c-_libssh2_ntohu32-cast-bit-shifting-40.patch
Patch2:      	fix-use-of-uninitialized-value-476-478.patch
Patch3:      	fix-heap-buffer-overflow-in-kex_agree_methods.patch
Patch4:		0001-packet.c-improved-parsing-in-packet_x11_open-410.patch
Patch5:		0001-packet.c-improved-packet-parsing-in-packet_queue_lis.patch

BuildRequires:	coreutils findutils zlib-devel man-db
BuildRequires:	gcc make sed openssl-devel > 1:1.0.1 openssh-server
BuildRequires:	glibc-langpack-en
Requires:       %{name}-help

%description
libssh2 is a library implementing the SSH2 protocol as defined by
Internet Drafts: SECSH-TRANS(22), SECSH-USERAUTH(25),
SECSH-CONNECTION(23), SECSH-ARCH(20), SECSH-FILEXFER(06)*,
SECSH-DHGEX(04), and SECSH-NUMBERS(10).

%package	devel
Summary:	Development files for libssh2
Requires:	%{name}%{?_isa} = %{version}-%{release} pkgconfig

%description	devel
The libssh2-devel package contains libraries and header files for
developing applications that use libssh2.

%package_help

%prep
%autosetup -n %{name}-%{version} -p1

sed -i s/4711/47%{__isa_bits}/ tests/ssh2.{c,sh}

%build
%configure --disable-silent-rules --enable-shared
%make_build

%install
%make_install
%delete_la

make -C example clean
rm -rf example/.deps
find example/ -type f '(' -name '*.am' -o -name '*.in' ')' -delete

mv -v example example.%{_arch}

%check
echo "Running tests for %{_arch}"
if [ ! -c /dev/tty ]; then
	echo Skipping SSH test due to missing /dev/tty
	echo "exit 0" > tests/ssh2.sh
fi
%ifarch %{sparc} %{arm}
echo Skipping SSH test on sparc/arm
echo "exit 0" > tests/ssh2.sh
%endif
%ifarch ppc %{power64} aarch64
echo "Skipping mansyntax test on PPC* and aarch64"
echo "exit 0" > tests/mansyntax.sh
%endif
LC_ALL=en_US.UTF-8 make -C tests check

%ldconfig_scriptlets

%files
%defattr(-,root,root)
%{!?_licensedir:%global license %%doc}
%doc docs/AUTHORS NEWS README RELEASE-NOTES
%license COPYING
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root)
%doc example.%{_arch}/
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/pkgconfig/*.pc

%files help
%defattr(-,root,root)
%doc docs/BINDINGS docs/HACKING docs/TODO NEWS
%{_mandir}/man3/libssh2_*.3*

%changelog
* Mon Nov 09 2020 xihaochen<xihaochen@huawei.com> - 1.9.0-6
- Type:requirement
- CVE:NA
- SUG:NA
- DESC:add libssh2-help dependency for libssh2

* Thu Sep 24 2020 yuboyun<yuboyun@huawei.com> - 1.9.0-5
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix heap-buffer-overflow in _libssh2_ntohu32 and wild-addr-read in _libssh2_ntohu32

* Thu Jun 4 2020 songzifeng<songzifeng1@huawei.com> - 1.9.0-4
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix heap buffer overflow in kex.c

* Sat May 30 2020 songzifeng<songzifeng1@huawei.com> - 1.9.0-3
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix use of uninitialized value in transport.c

* Sat Dec 21 2019 openEuler Buildteam <buildteam@openeuler.org> - 1.9.0-2
- Type:bugfix
- Id:NA
- SUG:NA
- DESC: add patches

* Sun Sep 15 2019 openEuler Buildteam <buildteam@openeuler.org> - 1.9.0-1
- Package init
